#!/usr/local/bin/perl
#
##########################################
#Author: Kishan Silva Ratnayake (ratki01)
#Created on: 10.16.2012
#Updated on: 10.16.2012
##########################################


use strict;
use warnings;
use REST::Client;
use Path::Class;
use XML::Tidy;
use autodie; # die if problem reading or writing a file

if(scalar(@ARGV) < 1)
{
        print "Please specify the DataAggregator IP/Hostname:<PORT>.";
        exit 1;
}

use Cwd 'abs_path';
#abs_path($0) =~ m/(.*\/)(.*\.pl)/;
abs_path($0) =~ m/(.*(\/|\\))(.*\.pl)/;
my $current_working_dir = $1;
if($^O =~ m/Win/)
{
	$current_working_dir =~ s/\//\\/g;
}


my $DA_URL = $ARGV[0];
my $client = REST::Client->new();
$client->setHost('http://'.$DA_URL);
$client->addHeader('Accept', 'application/xml');

$client->GET('/rest/devices/metricfamilysupporthistory');
my $tidy_obj = XML::Tidy->new( xml => $client->responseContent());
$tidy_obj->tidy();
$tidy_obj->write($current_working_dir.'metricfamily.txt');

my $dir = dir($current_working_dir);
my $file = $dir->file('metricfamily.txt');
my $content = $file->slurp();
my $file_handle = $file->openr();
my @metricFamily;
while( my $line = $file_handle->getline() ) {

           $line=~ s/^\s+//; 
           $line=~ s/\s+$//; 
           push(@metricFamily, $line);
}



$client->GET('/rest/devices');
$tidy_obj = XML::Tidy->new( xml => $client->responseContent());
$tidy_obj->tidy();
$tidy_obj->write($current_working_dir.'devices.txt');

$file = $dir->file('devices.txt');
$content = $file->slurp();
$file_handle = $file->openr();
my @devices;

my $writedir = dir($current_working_dir);
my $metric_list = $dir->file('unsupported_metric_family_list.html');
my $write_file_handle = $metric_list->openw();

while( my $line = $file_handle->getline() ) {
        
           $line=~ s/^\s+//; 
           $line=~ s/\s+$//; 
           push(@devices, $line);
}

my $x;
my $same_device=0;
my $metric_count=0;
my $has_status=0;
my $device_written=0;
my $device_id;
my $device_name;
my $ip_address;
my $metricFam_name='--';
my $vendor_cert='--';
my $status;
for($x=0;$x<scalar(@metricFamily);$x++)
{
           
           if($metricFamily[$x] =~ m/\<ConsolidatedAndDiscoveredMetricFamilyHistory version=.*\>/)
           {
                      $same_device=1;
                      
           }
           
           
           if($metricFamily[$x] =~ m/\<ID\>(.*)\<\/ID\>/)
           {
                     $device_id = $1;
                     my $id_set=0;
                     my $in_device=0;
                     #print "Device name: " . $device_name . "\n";
                     my $a;
                     for($a=0;$a<scalar(@devices);$a++)
                     {
                                 # if($devices[$a] =~ m/\<Device version=.*\>/)
                                 # {
                                            # $in_device = 1;
                                 # }
                                 
                                 if(($devices[$a] =~ m/\<ID\>(.*)\<\/ID\>/) && ($id_set == 0))
                                 {
                                            my $temp_id = $1;
                                            if($temp_id == $device_id)
                                            {
                                                       $id_set = 1;
                                            }                                      
                                 }
                                 
                                 if(($devices[$a] =~ m/\<PrimaryIPAddress\>(.*)\<\/PrimaryIPAddress\>/) && ($id_set==1))
                                 {
                                            $ip_address = $1;
                                 }
                                 
                                 if(($devices[$a] =~ m/\<Name\>(.*)\<\/Name\>/) && ($id_set==1))
                                 {
                                            $device_name = $1;
                                            $a = scalar(@devices);
                                 }
                                 
                                 # if($devices[$a] =~ m/\<\/Device\>/)
                                 # {
                                            # $in_device=0;
                                            # $id_set=0;
                                 # }
                                 
                     }
           }
           
                                     

           if($metricFamily[$x] =~ m/\<MetricFamilyID\>\{http:\/\/im.ca.com\/normalizer\}(.*)\<\/MetricFamilyID\>/)
           {
                      $metricFam_name= $1;
                      
                      if($metricFam_name =~ m/^Normalized(.*)/)
                      {
                                 $metricFam_name = $1;
                      }
                      
                      if($metricFam_name =~ m/(.*)Info$/)
                      {
                                 $metricFam_name = $1;
                      }
                      #print "metric fam name: " . $metricFam_name . "\n";
                      
           }
           
           
           if($metricFamily[$x] =~ m/\<VendorCertDisplayName\>(.*)\<\/VendorCertDisplayName\>/)
           {
                      $vendor_cert = $1;
                      #print "vendor cert: " . $vendor_cert . "\n";
           }
           
           if($metricFamily[$x] =~ m/\<Status\>(.*)\<\/Status\>/)
           {
                      $has_status=1;
                      $status = $1;
                      #print "Status: " . $status . "\n";
                      if ($status !~ m/^SUPPORTED$/)
                      {
                           $metric_count++;      
                           # print "status is other than SUPPORTED \n";
                           # print "same device status " . $same_device . "\n";
                           # print "metric count " . $metric_count . "\n";
                           if(($same_device == 1) && ($metric_count == 1))
                           {
                                 my $temp = '<b><p style="color:red">Device Name: '.$device_name. '(' . $ip_address . ')' .'</p></b>'."\n". 
                                 '<table border="1">'."\n".
                                 '<tr>'."\n".
                                 '<th>Metric Family</th>'."\n".
                                 '<th>Vendor Certificate</th>'."\n".
                                 '<th>Status</th>'."\n".
                                 '</tr>';
                                 # print "temp is: " . $temp . "\n";
                                 $write_file_handle->print($temp);
                                 $device_written=1;
                           }
                           
                           # print '<tr>'. "\n" . '<td>' . $metricFam_name . '</td>' . "\n" .
                           # '<td>' . $vendor_cert . '</td>' . "\n" .
                           # '<td>' . $status . '</td>' . "\n" .
                           # '</tr>';
                           
                           $write_file_handle->print('<tr>'. "\n" . '<td>' . $metricFam_name . '</td>' . "\n" .
                           '<td>' . $vendor_cert . '</td>' . "\n" .
                           '<td>' . $status . '</td>' . "\n" .
                           '</tr>');                           
                                 
                      }
           }
           
           
           if($metricFamily[$x] =~ m/\<\/ConsolidatedMetricFamilyList\>/)
           {
                      if($has_status==0)
                      {
                                 $metric_count++;
                                 if($device_written == 1)
                                 {
                                            $write_file_handle->print('<tr>'. "\n" . '<td>' . $metricFam_name . '</td>' . "\n" .
                                            '<td>' . $vendor_cert . '</td>' . "\n" .
                                            '<td>--</td>' . "\n" .
                                            '</tr>');
                                                    
                                 }
                                 else
                                 {
                                            if(($same_device == 1) && ($metric_count==1))
                                            {
                                                       my $temp = '<b><p style="color:red">Device Name: '.$device_name. '  (' . $ip_address . ')' . '</p></b>'."\n". 
                                                       '<table border="1">'."\n".
                                                       '<tr>'."\n".
                                                       '<th>Metric Family</th>'."\n".
                                                       '<th>Vendor Certificate</th>'."\n".
                                                       '<th>Status</th>'."\n".
                                                       '</tr>'; 
                                                       $write_file_handle->print($temp);
                                                       $write_file_handle->print('<tr>'. "\n" . '<td>' . $metricFam_name . '</td>' . "\n" .
                                                       '<td>' . $vendor_cert . '</td>' . "\n" .
                                                       '<td>--</td>' . "\n" .
                                                       '</tr>');
                                                       $device_written=1; 
                                                       
                                                       
                                            }
                                 }
                      }
                      else
                      {
                                 $has_status=0;
                      }
                      $metricFam_name = '--';
                      $vendor_cert='--';
           }

           
           if($metricFamily[$x] =~ m/\<\/ConsolidatedAndDiscoveredMetricFamilyHistory\>/)
           {
                      $same_device=0;
                      $metric_count=0;
                      $device_written=0;
                      $write_file_handle->print('</table>' . "\n" . '<br><br><br>');
                      # print '</table>' . "\n" . '<br><br><br>';
                      # print "=====================\n\n\n";
           }
           
           
}

print "\n\nPlease open the following HTML file in a web browser to view the list of unsupported metric families per device: \n" . $current_working_dir. "unsupported_metric_family_list.html";